' ########################################################################################
' This example creates two winsock controls, one in the port 1001 and the other in the port
' 1002. It uses the UDP protocol to echo the text written in the first edit control to the
' second winsock control. In the event WinsockControlEvents_DataArrival, we retrieve the
' text sent and output it in the second edit control.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL

#INCLUDE "mswinsck.inc"
#INCLUDE "ole2utils.inc"

%IDC_INPUT  = 1001
%IDC_OUTPUT = 1002

GLOBAL g_hDlg AS DWORD
GLOBAL pWinsockA AS IMSWinsockControl
GLOBAL pWinsockB AS IMSWinsockControl

' ========================================================================================
' Main
' ========================================================================================
FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

   LOCAL hDlg AS LONG

   DIALOG NEW 0, "Winsock UDP Test", , , 400, 240, %WS_OVERLAPPED OR %WS_THICKFRAME OR %WS_SYSMENU OR _
   %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX OR %WS_VISIBLE OR %DS_CENTER TO hDlg
   ' For icon from resource, instead use something like, LoadIcon(hInst, "APPICON")
   DIALOG SEND hDlg, %WM_SETICON, %ICON_SMALL, LoadIcon(%NULL, BYVAL %IDI_APPLICATION)
   DIALOG SEND hDlg, %WM_SETICON, %ICON_BIG, LoadIcon(%NULL, BYVAL %IDI_APPLICATION)
   CONTROL ADD TEXTBOX, hDlg, %IDC_INPUT, "Type some text and it will echoed in the second window", 5, 5, 388, 90, _
      %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %WS_VSCROLL OR %ES_MULTILINE, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hDlg, %IDC_OUTPUT, "", 5, 100, 388, 90, _
      %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %WS_VSCROLL OR %ES_MULTILINE OR %ES_READONLY, %WS_EX_CLIENTEDGE

   CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Close", 0, 0, 50, 14, %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_FLAT

   g_hDlg = hDlg

   DIALOG SHOW MODAL hDlg, CALL DlgProc

END FUNCTION
' ========================================================================================

' ========================================================================================
' Main Dialog procedure
' ========================================================================================
CALLBACK FUNCTION DlgProc() AS LONG

   LOCAL  rc AS RECT
   LOCAL  hr AS LONG
   LOCAL  strText AS STRING
   STATIC pWinsockEventsA AS DMSWinsockControlEventsAImpl
   STATIC pWinsockEventsB AS DMSWinsockControlEventsAImpl

   SELECT CASE CB.MSG

      CASE %WM_INITDIALOG
         ' Create the first winsock control
         ' Create a registration-free instance of the control
         pWinsockA = CreateInstanceFromDll(EXE.Path$ & "MSWINSCK.OCX", $CLSID_Winsock, $IID_IMSWinsockControl, $RTLKEY_Winsock)
         IF ISOBJECT(pWinsockA) THEN
            ' Connect to the events fired by the control
            pWinsockEventsA = CLASS "CDMSWinsockControlEventsA"
            IF ISOBJECT(pWinsockEventsA) THEN EVENTS FROM pWinsockA CALL pWinsockEventsA
            ' Set the UDP protocol
            pWinsockA.Protocol = %sckUDPProtocol
            ' Set the remote host using the computer "friendly" name
            pWinsockA.RemoteHost = UCODE$("PEPEHP")   ' <-- change as needed
            ' Set the remote port
            pWinsockA.RemotePort = 1001
            ' Bind it to the local port
            pWinsockA.Bind 1002
         END IF

         ' Create the second winsock control
         pWinsockB = CreateInstanceFromDll(EXE.Path$ & "MSWINSCK.OCX", $CLSID_Winsock, $IID_IMSWinsockControl, $RTLKEY_Winsock)
         IF ISOBJECT(pWinsockB) THEN
            ' Connect to the events fired by the control
            pWinsockEventsB = CLASS "CDMSWinsockControlEventsB"
            IF ISOBJECT(pWinsockEventsB) THEN EVENTS FROM pWinsockB CALL pWinsockEventsB
            ' Set the UDP protocol
            pWinsockB.Protocol = %sckUDPProtocol
            ' Set the remote host using the computer "friendly" name
            pWinsockB.RemoteHost = UCODE$("PEPEHP")   ' <-- change as needed
            ' Set the remote port
            pWinsockB.RemotePort = 1002
            ' Bind it to the local port
            pWinsockB.Bind 1001
         END IF

      CASE %WM_SIZE
         ' Resize the two sample buttons of the dialog
         IF CB.WPARAM <> %SIZE_MINIMIZED THEN
            GetClientRect CBHNDL, rc
            MoveWindow GetDlgItem(CB.HNDL, %IDC_INPUT), 10, 10, (rc.nRight - rc.nLeft) - 20, ((rc.nBottom - rc.nTop) \ 2) - 40, %TRUE
            MoveWindow GetDlgItem(CB.HNDL, %IDC_OUTPUT), 10, ((rc.nBottom - rc.nTop) \ 2) - 20, (rc.nRight - rc.nLeft) - 20, ((rc.nBottom - rc.nTop) \ 2) - 40, %TRUE
            MoveWindow GetDlgItem(CB.HNDL, %IDCANCEL), (rc.nRight - rc.nLeft) - 95, (rc.nBottom - rc.nTop) - 35, 75, 23, %TRUE
         END IF

      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDCANCEL
               IF CB.CTLMSG = %BN_CLICKED THEN DIALOG END CB.HNDL, 0
            CASE %IDC_INPUT
               IF CB.CTLMSG = %EN_CHANGE THEN
                  ' Retrieve the text of the input window
                  CONTROL GET TEXT CB.HNDL, %IDC_INPUT TO strText
                  ' Send the text
                  pWinsockA.SendData strText
               END IF
         END SELECT

      CASE %WM_DESTROY
         ' Close the connections
         IF pWinsockA.State <> %sckClosed THEN pWinsockA.Close
         IF pWinsockB.State <> %sckClosed THEN pWinsockB.Close
         ' Disconnect events
         IF ISOBJECT(pWinsockEventsA) THEN EVENTS END pWinsockEventsA
         IF ISOBJECT(pWinsockEventsB) THEN EVENTS END pWinsockEventsB
         ' Release the controls
         IF ISOBJECT(pWinsockA) THEN pWinsockA = NOTHING
         IF ISOBJECT(pWinsockB) THEN pWinsockB = NOTHING

   END SELECT

END FUNCTION
' ========================================================================================


' ########################################################################################
' Class CDMSWinsockControlEvents
' Interface name = DMSWinsockControlEvents
' IID = {248DD893-BB45-11CF-9ABC-0080C7E7B78D}
' Microsoft Winsock Control events
' Attributes = 4112 [&H1010] [Hidden] [Dispatchable]
' ########################################################################################

CLASS CDMSWinsockControlEventsA GUID$("{5DBC24EC-EEEB-4F33-BBD9-D1BEFACA501D}") AS EVENT

INTERFACE DMSWinsockControlEventsAImpl GUID$("{248DD893-BB45-11CF-9ABC-0080C7E7B78D}") AS EVENT

  INHERIT IDispatch

   ' =====================================================================================
   METHOD Error <6> ( _
     BYVAL Number AS INTEGER _                          ' Number VT_I2 <Integer>
   , BYREF Description AS STRING _                      ' *Description VT_BSTR
   , BYVAL Scode AS LONG _                              ' Scode VT_I4 <Long>
   , BYVAL bstrSource AS STRING _                       ' Source VT_BSTR
   , BYVAL HelpFile AS STRING _                         ' HelpFile VT_BSTR
   , BYVAL HelpContext AS LONG _                        ' HelpContext VT_I4 <Long>
   , BYREF CancelDisplay AS INTEGER _                   ' *CancelDisplay VT_BOOL <Integer>
   )                                                    ' void

     SetWindowText g_Hdlg, "Error " & FORMAT$(Scode) & " - " & ACODE$(Description)

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD DataArrival <0> ( _
     BYVAL bytesTotal AS LONG _                         ' bytesTotal VT_I4 <Long>
   )                                                    ' void

      ' Retrieve the text received and output it in the output window
      LOCAL vData AS VARIANT
      pWinsockA.GetData vData, 8   ' %vbString = 8
      CONTROL SET TEXT g_hDlg, %IDC_OUTPUT, VARIANT$(vData)

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD Connect <1>

      SetWindowText g_Hdlg, "Connect"

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD ConnectionRequest <2> ( _
     BYVAL requestID AS LONG _                          ' requestID VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD Close <5>

      SetWindowText g_Hdlg, "Close"

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD SendProgress <3> ( _
     BYVAL bytesSent AS LONG _                          ' bytesSent VT_I4 <Long>
   , BYVAL bytesRemaining AS LONG _                     ' bytesRemaining VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD SendComplete <4>

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

END INTERFACE

END CLASS


CLASS CDMSWinsockControlEventsB GUID$("{5DBC24EC-EEEB-4F33-BBD9-D1BEFACA501E}") AS EVENT

INTERFACE DMSWinsockControlEventsBImpl GUID$("{248DD893-BB45-11CF-9ABC-0080C7E7B78D}") AS EVENT

  INHERIT IDispatch

   ' =====================================================================================
   METHOD Error <6> ( _
     BYVAL Number AS INTEGER _                          ' Number VT_I2 <Integer>
   , BYREF Description AS STRING _                      ' *Description VT_BSTR
   , BYVAL Scode AS LONG _                              ' Scode VT_I4 <Long>
   , BYVAL bstrSource AS STRING _                       ' Source VT_BSTR
   , BYVAL HelpFile AS STRING _                         ' HelpFile VT_BSTR
   , BYVAL HelpContext AS LONG _                        ' HelpContext VT_I4 <Long>
   , BYREF CancelDisplay AS INTEGER _                   ' *CancelDisplay VT_BOOL <Integer>
   )                                                    ' void

     SetWindowText g_Hdlg, "Error " & FORMAT$(Scode) & " - " & ACODE$(Description)

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD DataArrival <0> ( _
     BYVAL bytesTotal AS LONG _                         ' bytesTotal VT_I4 <Long>
   )                                                    ' void

      ' Retrieve the text received and output it in the output window
      LOCAL vData AS VARIANT
      pWinsockB.GetData vData, 8   ' %vbString = 8
      CONTROL SET TEXT g_hDlg, %IDC_OUTPUT, VARIANT$(vData)

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD Connect <1>

      SetWindowText g_Hdlg, "Connect"

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD ConnectionRequest <2> ( _
     BYVAL requestID AS LONG _                          ' requestID VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD Close <5>

      SetWindowText g_Hdlg, "Close"

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD SendProgress <3> ( _
     BYVAL bytesSent AS LONG _                          ' bytesSent VT_I4 <Long>
   , BYVAL bytesRemaining AS LONG _                     ' bytesRemaining VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD SendComplete <4>

     ' *** Insert your code here ***

   END METHOD
   ' =====================================================================================

END INTERFACE

END CLASS
